Index: src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision 1cf490b648906629e67d57ec00ad3cd52e08523f)
@@ -18,5 +18,5 @@
 matplotlib.use('WXAgg')
 from matplotlib.backends.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
-from matplotlib.backends.backend_wxagg import NavigationToolbar2Wx as Toolbar
+from matplotlib.backends.backend_wxagg import NavigationToolbar2WxAgg as Toolbar
 from matplotlib.backend_bases import FigureManagerBase
 # Wx-Pylab magic for displaying plots within an application's window.
Index: src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py	(revision d78861987017138f4c36cc97a261c26e80c03f64)
@@ -248,4 +248,6 @@
             Complete the loading and compute the slit size
         """
+        if isinstance(data, list):
+            data = data[0]
         if data is None or data.__class__.__name__ == 'Data2D':
             if self.parent.parent is None:
Index: src/sas/sasgui/perspectives/fitting/basepage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/basepage.py	(revision 1f4d708b9de04a250ee358a7821a2cdb9f0e7d75)
+++ src/sas/sasgui/perspectives/fitting/basepage.py	(revision b43988196e5c4f2dfbf3ec5c9b66703d5656b08d)
@@ -31,4 +31,5 @@
 
 from sas.sasgui.guiframe.panel_base import PanelBase
+from sas.sasgui.guiframe.report_image_handler import ReportImageHandler
 from sas.sasgui.guiframe.utils import format_number, check_float, IdList, \
     check_int
@@ -641,8 +642,7 @@
         # get the strings for report
         report_str, text_str = self.state.report(fig_urls=refs)
-
         # Show the dialog
         report_list = [report_str, text_str, images]
-        dialog = ReportDialog(report_list, None, wx.ID_ANY, "")
+        dialog = ReportDialog(report_list, imgRAM, refs, None, wx.ID_ANY, "")
         dialog.Show()
 
@@ -652,35 +652,10 @@
         by plotting, putting it into wx.FileSystem image object
         """
-        images = []
-        refs = []
-
-        # For no figures in the list, prepare empty plot
-        if figs is None or len(figs) == 0:
-            figs = [None]
-
-        # Loop over the list of figures
-        # use wx.MemoryFSHandler
-        imgRAM = wx.MemoryFSHandler()
-        for fig in figs:
-            if fig is not None:
-                ind = figs.index(fig)
-                canvas = canvases[ind]
-
-            # store the image in wx.FileSystem Object
-            wx.FileSystem.AddHandler(wx.MemoryFSHandler())
-
-            # index of the fig
-            ind = figs.index(fig)
-
-            # AddFile, image can be retrieved with 'memory:filename'
-            name = 'img_fit%s.png' % ind
-            refs.append('memory:' + name)
-            imgRAM.AddFile(name, canvas.bitmap, wx.BITMAP_TYPE_PNG)
-
-            # append figs
-            images.append(fig)
-
-        return imgRAM, images, refs
-
+        bitmaps = []
+        for canvas in canvases:
+            bitmaps.append(canvas.bitmap)
+        imgs, refs = ReportImageHandler.set_figs(figs, bitmaps, 'fit')
+
+        return ReportImageHandler.instance, imgs, refs
 
     def on_save(self, event):
@@ -1472,7 +1447,9 @@
             # we need to check here ourselves.
             if not is_modified:
-                is_modified = (self._check_value_enter(self.fittable_param)
-                               or self._check_value_enter(self.fixed_param)
-                               or self._check_value_enter(self.parameters))
+                is_modified = self._check_value_enter(self.fittable_param)
+                is_modified = self._check_value_enter(
+                    self.fixed_param) or is_modified
+                is_modified = self._check_value_enter(
+                    self.parameters) or is_modified
 
             # Here we should check whether the boundaries have been modified.
@@ -1536,7 +1513,7 @@
                         data=[self.data])
             # Check the values
-            is_modified = (self._check_value_enter(self.fittable_param)
-                           or self._check_value_enter(self.fixed_param)
-                           or self._check_value_enter(self.parameters))
+            is_modified = self._check_value_enter(self.fittable_param)
+            is_modified = self._check_value_enter(self.fixed_param) or is_modified
+            is_modified = self._check_value_enter(self.parameters) or is_modified
 
             # If qmin and qmax have been modified, update qmin and qmax and
@@ -2324,5 +2301,6 @@
 
             # Update value in model if it has changed
-            if value != self.model.getParam(name):
+            if (value != self.model.getParam(name) or
+                    (np.isnan(value) and np.isnan(self.model.getParam(name)))):
                 self.model.setParam(name, value)
                 is_modified = True
@@ -2551,4 +2529,5 @@
             # draw
             self._draw_model()
+            self.Layout()
             self.Refresh()
         except Exception:
@@ -2799,17 +2778,21 @@
         Function called when 'Help' button is pressed next to model
         of interest.  This calls DocumentationWindow from
-        documentation_window.py. It will load the top level of the model
-        help documenation sphinx generated html if no model is presented.
-        If a model IS present then if documention for that model exists
-        it will load to that  point otherwise again it will go to the top.
-        For Wx2.8 and below is used (i.e. non-released through installer)
-        a browser is loaded and the top of the model documentation only is
-        accessible because webbrowser module does not pass anything after
-        the # to the browser.
+        documentation_window.py. It will load the top level of the html model
+        help documenation sphinx generated if either a plugin model (which
+        normally does not have an html help help file) is selected or if no
+        model is selected. Otherwise, if a regula model is selected, the
+        documention for that model will be sent to a browser window.
+
+        :todo the quick fix for no documentation in plugins is the if statment.
+        However, the right way to do this would be to check whether the hmtl
+        file exists and load the model docs if it does and the general docs if
+        it doesn't - this will become important if we ever figure out how to
+        build docs for plugins on the fly.  Sep 9, 2018 -PDB
 
         :param event: on Help Button pressed event
         """
 
-        if self.model is not None:
+        if (self.model is not None) and (self.categorybox.GetValue()
+                                         != "Plugin Models"):
             name = self.formfactorbox.GetValue()
             _TreeLocation = 'user/models/%s.html' % name
Index: src/sas/sasgui/perspectives/fitting/fitpage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitpage.py	(revision e8707025646922ab7fc3e234f1a9aee4a6b09ba2)
+++ src/sas/sasgui/perspectives/fitting/fitpage.py	(revision dabcaf7ca863c03f09de926ea406e209584fcc67)
@@ -705,7 +705,6 @@
 
                         ix = 3
-                        ctl2 = wx.TextCtrl(self, wx.ID_ANY,
-                                           size=(_BOX_WIDTH / 1.3, 20),
-                                           style=0)
+                        ctl2 = BGTextCtrl(self, wx.ID_ANY,
+                                           size=(_BOX_WIDTH / 1.3, 20))
 
                         self.sizer4_4.Add(ctl2, (iy, ix), (1, 1),
@@ -1997,4 +1996,5 @@
         self.on_smear_helper()
         self.on_set_focus(None)
+        self.Layout()
         self.Refresh()
         # update model plot with new data information
@@ -2891,6 +2891,6 @@
                         text2.Hide()
                     ix += 1
-                    ctl2 = wx.TextCtrl(self, wx.ID_ANY,
-                                       size=(_BOX_WIDTH / 1.2, 20), style=0)
+                    ctl2 = BGTextCtrl(self, wx.ID_ANY,
+                                       size=(_BOX_WIDTH / 1.2, 20))
                     sizer.Add(ctl2, (iy, ix), (1, 1),
                               wx.EXPAND | wx.ADJUST_MINSIZE, 0)
Index: src/sas/sasgui/perspectives/fitting/gpu_options.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/gpu_options.py	(revision 42a6e029d713dd90abf6af8ac04156c566900404)
+++ src/sas/sasgui/perspectives/fitting/gpu_options.py	(revision 388aefbfe7862efae1f1595105c7a8b53bb3e8e3)
@@ -139,4 +139,7 @@
 
         test_text = wx.StaticText(self, -1, "WARNING: Running tests can take a few minutes!")
+        test_text2 = wx.StaticText(self, -1, "NOTE: No test will run if No OpenCL is checked")
+        test_text.SetForegroundColour(wx.RED)
+        self.vbox.Add(test_text2, 0, wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 10)
         self.vbox.Add(test_text, 0, wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 10)
 
Index: src/sas/sasgui/perspectives/fitting/report_dialog.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/report_dialog.py	(revision 69a68979fe94b8f135a602e7f02b162e34616d53)
+++ src/sas/sasgui/perspectives/fitting/report_dialog.py	(revision 44e8f48e6ada97db8eb483009edc07705c6329a2)
@@ -72,14 +72,12 @@
         filename = basename + ext
 
-        # save figures
-        pictures = []
-        for num in range(self.nimages):
-            pic_name = basename + '_img%s.png' % num
-            # save the image for use with pdf writer
-            self.report_list[2][num].savefig(pic_name)
-            pictures.append(pic_name)
+        # save the images for use with pdf writer
+        pictures = [
+            '_'.join((basename, url.split(':')[1])) for url in self.fig_urls]
+        for i, pic in enumerate(pictures):
+            self.report_list[2][i].savefig(pic)
 
         # translate png references int html from in-memory name to on-disk name
-        html = self.report_html.replace("memory:img_fit", basename+'_img')
+        html = self.report_html.replace("memory:", basename+'_')
 
         #set file extensions
Index: src/sas/sasgui/perspectives/invariant/invariant_panel.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 2469df7fc9ffa047115c5bffe589ed307b12c363)
+++ src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 44e8f48e6ada97db8eb483009edc07705c6329a2)
@@ -24,4 +24,5 @@
 from sas.sasgui.guiframe.panel_base import PanelBase
 from sas.sasgui.guiframe.documentation_window import DocumentationWindow
+from sas.sasgui.guiframe.report_image_handler import ReportImageHandler
 
 logger = logging.getLogger(__name__)
@@ -783,5 +784,8 @@
         report_img = self.state.image
         report_list = [report_html_str, report_text_str, report_img]
-        dialog = ReportDialog(report_list, None, -1, "")
+        ReportImageHandler.check_for_empty_instance()
+        imgRAM = ReportImageHandler.instance.img_holder
+        refs = [self.state.wximgbmp]
+        dialog = ReportDialog(report_list, imgRAM, refs, None, wx.ID_ANY, "")
         dialog.Show()
 
Index: src/sas/sasgui/perspectives/invariant/invariant_state.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision 2469df7fc9ffa047115c5bffe589ed307b12c363)
+++ src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision fa412df39d3c5338c2c5f69fed935b428f385ebe)
@@ -12,4 +12,5 @@
 from lxml import etree
 from sas.sascalc.dataloader.readers.cansas_reader import Reader as CansasReader
+from sas.sasgui.guiframe.report_image_handler import ReportImageHandler
 from sas.sascalc.dataloader.readers.cansas_reader import get_content
 from sas.sasgui.guiframe.utils import format_number
@@ -611,12 +612,8 @@
         wximgbmp = wx.BitmapFromImage(wximg)
         # store the image in wx.FileSystem Object
-        wx.FileSystem.AddHandler(wx.MemoryFSHandler())
-        # use wx.MemoryFSHandler
-        self.imgRAM = wx.MemoryFSHandler()
-        # AddFile, image can be retrieved with 'memory:filename'
-        self.imgRAM.AddFile('img_inv.png', wximgbmp, wx.BITMAP_TYPE_PNG)
-
-        self.wximgbmp = 'memory:img_inv.png'
-        self.image = fig
+        imgs, refs = ReportImageHandler.set_figs([fig], [wximgbmp], 'inv')
+
+        self.wximgbmp = refs[0]
+        self.image = imgs[0]
 
 class Reader(CansasReader):
Index: src/sas/sasgui/perspectives/invariant/report_dialog.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/report_dialog.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/invariant/report_dialog.py	(revision d0ce666faaf0f9284be2e607a0ac846cdd9a682b)
@@ -41,5 +41,5 @@
 
         # put image path in the report string
-        self.report_html = self.report_list[0] % "memory:img_inv.png"
+        self.report_html = self.report_list[0] % self.fig_urls[0]
         # layout
         self._setup_layout()
Index: src/sas/sasview/local_config.py
===================================================================
--- src/sas/sasview/local_config.py	(revision b963b2066d6a76fe5073000c5a596a6fd0130ac4)
+++ src/sas/sasview/local_config.py	(revision 8ac05a59a0078f40fc8af4febae16624b9d5c818)
@@ -33,4 +33,5 @@
 _do_aboutbox = True
 _do_acknowledge = True
+_do_release = True
 _do_tutorial = True
 _acknowledgement_preamble =\
@@ -48,6 +49,5 @@
 '''This work benefited from the use of the SasView application, originally developed under NSF Award DMR-0520547. SasView also contains code developed with funding from the EU Horizon 2020 programme under the SINE2020 project Grant No 654000.'''
 _acknowledgement_citation = \
-'''M. Doucet et al. SasView Version 4.1.2, Zenodo, 10.5281/zenodo.825675'''
-
+'''M. Doucet et al. SasView Version 4.2, Zenodo, 10.5281/zenodo.1412041'''
 _acknowledgement =  \
 '''This work was originally developed as part of the DANSE project funded by the US NSF under Award DMR-0520547,\n but is currently maintained by a collaboration between UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, DLS, and the scattering community.\n\n SasView also contains code developed with funding from the EU Horizon 2020 programme under the SINE2020 project (Grant No 654000).\nA list of individual contributors can be found at: http://www.sasview.org/contact.html
@@ -94,5 +94,5 @@
 _corner_image = os.path.join(icon_path, "angles_flat.png")
 _welcome_image = os.path.join(icon_path, "SVwelcome.png")
-_copyright = "(c) 2009 - 2017, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, and DLS"
+_copyright = "(c) 2009 - 2018, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, and DLS"
 marketplace_url = "http://marketplace.sasview.org/"
 
Index: src/sas/sasview/media/.gitignore
===================================================================
--- src/sas/sasview/media/.gitignore	(revision 356af60ef4067ec412316b5d0ea7e787955d8487)
+++ src/sas/sasview/media/.gitignore	(revision 356af60ef4067ec412316b5d0ea7e787955d8487)
@@ -0,0 +1,1 @@
+/README.txt
Index: src/sas/sasview/sasview.py
===================================================================
--- src/sas/sasview/sasview.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
+++ src/sas/sasview/sasview.py	(revision 1270e3c4e7a4343f5a384a6bf3799b972b00c1d2)
@@ -43,4 +43,6 @@
         from sas.sasgui.guiframe.gui_manager import SasViewApp
         self.gui = SasViewApp(0)
+        if sys.platform == "darwin":
+            self.check_sasmodels_compiler()
         # Set the application manager for the GUI
         self.gui.set_manager(self)
@@ -130,4 +132,58 @@
         self.gui.MainLoop()
 
+    def check_sasmodels_compiler(self):
+        """
+        Checking c compiler for sasmodels and raises xcode command line
+        tools for installation
+        """
+        #wx should be importable at this stage
+        import wx
+        import subprocess
+        #Generic message box created becuase standard MessageBox is not moveable
+        class GenericMessageBox(wx.Dialog):
+            def __init__(self, parent, text, title = ''):
+
+                wx.Dialog.__init__(self, parent, -1, title = title,
+                               size = (360,200), pos=(20,60),
+                               style = wx.STAY_ON_TOP | wx.DEFAULT_DIALOG_STYLE)
+                panel = wx.Panel(self, -1)
+                top_row_sizer = wx.BoxSizer(wx.HORIZONTAL)
+
+                error_bitmap = wx.ArtProvider.GetBitmap(
+                    wx.ART_ERROR, wx.ART_MESSAGE_BOX
+                )
+                error_bitmap_ctrl = wx.StaticBitmap(panel, -1)
+                error_bitmap_ctrl.SetBitmap(error_bitmap)
+                label = wx.StaticText(panel, -1, text)
+                top_row_sizer.Add(error_bitmap_ctrl, flag=wx.ALL, border=10)
+                top_row_sizer.Add(label, flag=wx.ALIGN_CENTER_VERTICAL)
+
+                #Create the OK button in the bottom row.
+                ok_button = wx.Button(panel, wx.ID_OK )
+                self.Bind(wx.EVT_BUTTON, self.on_ok, source=ok_button)
+                ok_button.SetFocus()
+                ok_button.SetDefault()
+
+                sizer = wx.BoxSizer(wx.VERTICAL)
+                sizer.Add(top_row_sizer)
+                sizer.Add(ok_button, flag=wx.ALIGN_CENTER | wx.ALL, border=5)
+                panel.SetSizer(sizer)
+
+            def on_ok(self, event):
+                self.Destroy()
+
+        logger = logging.getLogger(__name__)
+        try:
+            subprocess.check_output(["cc","--version"], stderr=subprocess.STDOUT)
+        except subprocess.CalledProcessError as exc:
+            dlg = GenericMessageBox(parent=None,
+            text='No compiler installed. Please install command line\n'
+                'developers tools by clicking \"Install\" in another winodw\n\n'
+                'Alternatively click \"Not Now\" and use OpenCL\n'
+                 'compiler, which can be set up from menu Fitting->OpenCL Options\n\n',
+            title = 'Compiler Info')
+            dlg.Show()
+            logger.error("No compiler installed. %s\n"%(exc))
+            logger.error(traceback.format_exc())
 
 def setup_logging():
Index: test/corfunc/test/utest_corfunc.py
===================================================================
--- test/corfunc/test/utest_corfunc.py	(revision f53d684ed4a54de3601e5f4bc601f78376d98e83)
+++ test/corfunc/test/utest_corfunc.py	(revision 6ef75fa6bf95901e6d1172fe707772bc581fdba2)
@@ -74,12 +74,14 @@
         while True:
             time.sleep(0.001)
-            if not self.calculator.transform_isrunning():
+            if (not self.calculator.transform_isrunning() and
+                self.transformation is not None):
                 break
 
-    def transform_callback(self, transforms):
-        transform1, transform3, idf = transforms
+        transform1, transform3, idf = self.transformation
         self.assertIsNotNone(transform1)
         self.assertAlmostEqual(transform1.y[0], 1)
         self.assertAlmostEqual(transform1.y[-1], 0, 5)
+
+    def transform_callback(self, transforms):
         self.transformation = transforms
 
Index: test/sasdataloader/test/utest_abs_reader.py
===================================================================
--- test/sasdataloader/test/utest_abs_reader.py	(revision fa749b7a4a403e49b9aa36906bc99a8352341221)
+++ test/sasdataloader/test/utest_abs_reader.py	(revision bd5c3b11a604dfd75fa3d6424e1ea40bcafd3727)
@@ -53,7 +53,7 @@
 
         self.assertEqual(self.data.y_unit, 'cm^{-1}')
-        self.assertEqual(self.data.x[0], 0.002618)
-        self.assertEqual(self.data.x[1], 0.007854)
-        self.assertEqual(self.data.x[2], 0.01309)
+        self.assertEqual(self.data.x[0], 0.008082)
+        self.assertEqual(self.data.x[1], 0.0275)
+        self.assertEqual(self.data.x[2], 0.02762)
         self.assertEqual(self.data.x[126], 0.5828)
 
